# [Shapeshifting] General 20Hz function.
execute as @a if entity @s[tag=nehp.oni.shapeshifted] at @s run function nehp:oni/shapeshift/tick

# [Clouds] Manifesting clouds FX 20Hz functions.
execute at @a[tag=nehp.oni.cloud_manifesting] as @e[tag=nehp.oni.cloud_manifestation,type=marker,distance=..16,sort=nearest,limit=1] run tp @s ~ ~1 ~
execute at @a[tag=nehp.oni.cloud_manifesting] as @e[tag=nehp.oni.cloud_manifestation,type=marker,distance=..16,sort=nearest,limit=1] at @s run function nehp:oni/clouds/tick

# [Clouds] Projectile 20Hz functions.
execute at @a as @e[type=marker,tag=nehp.oni.shatter_projectile,distance=..64] at @s run function nehp:oni/clouds/shatter/projectile
execute as @a[scores={nehp.oni.shatter_casted=0..}] run scoreboard players remove @s nehp.oni.shatter_casted 1

# Loop #quickTick
scoreboard players add #quickTick nehp.oni.tick 1
execute if score #quickTick nehp.oni.tick matches 20.. run scoreboard players set #quickTick nehp.oni.tick 0

# More expensive functions that require slower tick rates, or general commands that don't need to be run at 20Hz.
# nehp:oni/tick/8 -> 8 times per second (8Hz);
# nehp:oni/tick/1 -> 1 time per second (1Hz);
execute if score #quickTick nehp.oni.tick matches 0 run function nehp:oni/tick/8
execute if score #quickTick nehp.oni.tick matches 3 run function nehp:oni/tick/8
execute if score #quickTick nehp.oni.tick matches 6 run function nehp:oni/tick/8
execute if score #quickTick nehp.oni.tick matches 8 run function nehp:oni/tick/8
execute if score #quickTick nehp.oni.tick matches 9 run function nehp:oni/tick/1
execute if score #quickTick nehp.oni.tick matches 10 run function nehp:oni/tick/8
execute if score #quickTick nehp.oni.tick matches 13 run function nehp:oni/tick/8
execute if score #quickTick nehp.oni.tick matches 15 run function nehp:oni/tick/8
execute if score #quickTick nehp.oni.tick matches 18 run function nehp:oni/tick/8